package oracle.jrockit.jfr.parser;

import java.io.Closeable;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.RandomAccessFile;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.channels.FileChannel.MapMode;
import java.util.Iterator;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.sax.TransformerHandler;
import javax.xml.transform.stream.StreamResult;
import oracle.jrockit.jfr.parser.ChunkParser;
import oracle.jrockit.jfr.parser.FLREvent;
import oracle.jrockit.jfr.parser.FLRInput;
import oracle.jrockit.jfr.parser.MappedFLRInput;
import oracle.jrockit.jfr.parser.ParseException;
import oracle.jrockit.jfr.parser.RandomAccessFileFLRInput;
import org.xml.sax.ContentHandler;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.AttributesImpl;

/** @deprecated */
@Deprecated
public final class Parser implements Iterable, Closeable {

   private final FLRInput input;
   private long nextChunk;
   static final String JFR_URI = "http://www.oracle.com/hotspot/jvm/";
   static final String JFR_NS = "jfr";


   public Parser(String var1) throws IOException {
      this((String)var1, true);
   }

   public Parser(String var1, boolean var2) throws IOException {
      this((File)(new File(var1)));
   }

   public Parser(File var1, boolean var2) throws IOException {
      RandomAccessFile var3 = new RandomAccessFile(var1, "r");
      long var4 = var3.length();
      Object var6 = null;
      if(var2 && var4 < 52428800L) {
         FileChannel var7 = var3.getChannel();

         try {
            MappedByteBuffer var8 = var7.map(MapMode.READ_ONLY, 0L, var4);
            var6 = new MappedFLRInput(var8);
         } catch (IOException var9) {
            ;
         }
      }

      if(var6 == null) {
         var6 = new RandomAccessFileFLRInput(var3);
      }

      this.input = (FLRInput)var6;
   }

   public Parser(File var1) throws IOException {
      this((File)var1, true);
   }

   public ChunkParser next() throws IOException, ParseException {
      if(this.nextChunk >= this.input.size()) {
         return null;
      } else {
         this.input.position(this.nextChunk);
         ChunkParser var1 = new ChunkParser(this.input);
         this.nextChunk = var1.getChunkEnd();
         return var1;
      }
   }

   public void writeXML(ContentHandler var1) throws SAXException, IOException, ParseException {
      var1.startElement("http://www.oracle.com/hotspot/jvm/", "flightrecording", "jfr:flightrecording", new AttributesImpl());

      ChunkParser var2;
      while((var2 = this.next()) != null) {
         var2.writeXML(var1);
      }

      var1.endElement("http://www.oracle.com/hotspot/jvm/", "flightrecording", "jfr:flightrecording");
   }

   public Iterator iterator() {
      return new Iterator() {

         private ChunkParser p;

         public boolean hasNext() {
            try {
               this.p = Parser.this.next();
            } catch (Exception var2) {
               throw new RuntimeException(var2);
            }

            return this.p != null;
         }
         public ChunkParser next() {
            return this.p;
         }
         public void remove() {
            throw new UnsupportedOperationException();
         }
      };
   }

   public void close() throws IOException {
      this.input.close();
   }

   public static void main(String[] var0) throws Exception {
      int var1 = 0;
      boolean var2 = false;
      if(var0[0].equals("-xml")) {
         var2 = true;
         ++var1;
      }

      Parser var3 = new Parser(var0[var1]);
      Throwable var4 = null;

      try {
         if(var2) {
            TransformerFactory var27 = TransformerFactory.newInstance();
            if(!var27.getFeature("http://javax.xml.transform.sax.SAXTransformerFactory/feature")) {
               throw new SAXException("cannot construct output handler");
            }

            SAXTransformerFactory var28 = (SAXTransformerFactory)var27;
            var28.setAttribute("indent-number", "3");
            TransformerHandler var7 = var28.newTransformerHandler();
            var7.getTransformer().setOutputProperty("method", "xml");
            var7.getTransformer().setOutputProperty("indent", "yes");
            var7.getTransformer().setOutputProperty("encoding", "iso-8859-1");
            PrintWriter var8 = new PrintWriter(System.out);
            var7.setResult(new StreamResult(var8));
            var3.writeXML(var7);
            var8.flush();
            return;
         }

         ChunkParser var5;
         try {
            while((var5 = var3.next()) != null) {
               System.out.println("new chunk");

               FLREvent var6;
               while((var6 = var5.next()) != null) {
                  System.out.println(var6);
               }
            }
         } finally {
            System.out.flush();
         }
      } catch (Throwable var25) {
         var4 = var25;
         throw var25;
      } finally {
         if(var3 != null) {
            if(var4 != null) {
               try {
                  var3.close();
               } catch (Throwable var23) {
                  var4.addSuppressed(var23);
               }
            } else {
               var3.close();
            }
         }

      }

   }
}
